Ruby: include/ruby/internal/intern/parse.h File Reference

Ruby 3.0.5p211 (2022-11-24 revision ba5cf0f7c52d4d35cc6a173c89eda98ceffa2dcf)

Functions
parse.h File Reference

Public APIs related to rb_cSymbol. More...

`#include "ruby/internal/attr/const.h"`
`#include "ruby/internal/dllexport.h"`
`#include "ruby/internal/value.h"`

Go to the source code of this file.

## Functions
ID | rb_id_attrset (ID)
int | rb_is_const_id (ID)
int | rb_is_global_id (ID)
int | rb_is_instance_id (ID)
int | rb_is_attrset_id (ID)
int | rb_is_class_id (ID)
int | rb_is_local_id (ID)
int | rb_is_junk_id (ID)
int | rb_symname_p (const char *)
int | rb_sym_interned_p (VALUE)
VALUE | rb_backref_get (void)
void | rb_backref_set (VALUE)
VALUE | rb_lastline_get (void)
void | rb_lastline_set (VALUE)
VALUE | rb_sym_all_symbols (void)

## Detailed Description

Public APIs related to rb_cSymbol.

Author
  Ruby developers ruby-.nosp@m.core.nosp@m.@ruby.nosp@m.-lan.nosp@m.g.org

Copyright
  This file is a part of the programming language Ruby. Permission is hereby granted, to either redistribute and/or modify this file, provided that the conditions mentioned in the file COPYING are met. Consult the file for details.

Warning
  Symbols prefixed with either `RBIMPL` or `rbimpl` are implementation details. Don't take them as canon. They could rapidly appear then vanish. The name (path) of this header file is also an implementation detail. Do not expect it to persist at the place it is now. Developers are free to move it anywhere anytime at will.

Note
  To ruby-core: remember that this header can be possibly recursively included from extension libraries written in C++. Do not expect for instance `__VA_ARGS__` is always available. We assume C99 for ruby itself but we don't assume languages of extension libraries. They could be written in C++98.

Definition in file parse.h.

## Function Documentation

## ◆ rb_backref_get()

VALUE rb_backref_get | ( | void |  | ) |

Definition at line 1544 of file vm.c.

References VM_SVAR_BACKREF.

Referenced by date__httpdate(), date__iso8601(), date__jisx0301(), date__parse(), date__rfc2822(), date__rfc3339(), date__xmlschema(), rb_backref_set_string(), rb_f_global_variables(), and rb_reg_start_with_p().

## ◆ rb_backref_set()

void rb_backref_set | ( | VALUE | val | ) |

Definition at line 1550 of file vm.c.

References VM_SVAR_BACKREF.

Referenced by date__httpdate(), date__iso8601(), date__jisx0301(), date__parse(), date__rfc2822(), date__rfc3339(), date__xmlschema(), rb_backref_set_string(), rb_reg_eqq(), rb_reg_match2(), and rb_reg_start_with_p().

## ◆ rb_id_attrset()

ID rb_id_attrset | ( | ID | id | ) |

Definition at line 113 of file symbol.c.

References id, ID_ATTRSET, ID_CLASS, ID_CONST, ID_GLOBAL, ID_INSTANCE, ID_JUNK, ID_LOCAL, id_types, is_notop_id, PRIsVALUE, PRIxVALUE, Qnil, rb_id2str, rb_name_error(), rb_name_error_str(), rb_str_cat(), rb_str_dup(), rb_sym2id(), str, sym, tAREF, and tASET.

Referenced by rb_attr().

## ◆ rb_is_attrset_id()

int rb_is_attrset_id | ( | ID | id | ) |

Definition at line 1028 of file symbol.c.

References is_attrset_id.

## ◆ rb_is_class_id()

int rb_is_class_id | ( | ID | id | ) |

Definition at line 1010 of file symbol.c.

References is_class_id.

## ◆ rb_is_const_id()

int rb_is_const_id | ( | ID | id | ) |

Definition at line 1004 of file symbol.c.

References is_const_id.

Referenced by rb_autoload_str(), and rb_define_const().

## ◆ rb_is_global_id()

int rb_is_global_id | ( | ID | id | ) |

Definition at line 1016 of file symbol.c.

References is_global_id.

## ◆ rb_is_instance_id()

int rb_is_instance_id | ( | ID | id | ) |

Definition at line 1022 of file symbol.c.

References is_instance_id.

Referenced by rb_ivar_set_internal().

## ◆ rb_is_junk_id()

int rb_is_junk_id | ( | ID | id | ) |

Definition at line 1040 of file symbol.c.

References is_junk_id.

## ◆ rb_is_local_id()

int rb_is_local_id | ( | ID | id | ) |

Definition at line 1034 of file symbol.c.

References is_local_id.

## ◆ rb_lastline_get()

VALUE rb_lastline_get | ( | void |  | ) |

Definition at line 1556 of file vm.c.

References VM_SVAR_LASTLINE.

Referenced by rb_io_print(), and rb_reg_match2().

## ◆ rb_lastline_set()

void rb_lastline_set | ( | VALUE | val | ) |

Definition at line 1562 of file vm.c.

References VM_SVAR_LASTLINE.

Referenced by rb_gets().

## ◆ rb_sym_all_symbols()

VALUE rb_sym_all_symbols | ( | void |  | ) |

Definition at line 983 of file symbol.c.

References RString::ary, GLOBAL_SYMBOLS_ENTER, GLOBAL_SYMBOLS_LEAVE, st_table::num_entries, rb_ary_new2, st_foreach, and rb_symbols_t::str_sym.

## ◆ rb_sym_interned_p()

int rb_sym_interned_p | ( | VALUE |  | ) |

## ◆ rb_symname_p()

int rb_symname_p | ( | const char * | name | ) |

Definition at line 197 of file symbol.c.

References name, rb_ascii8bit_encoding(), and rb_enc_symname_p().